// Code generated by goa v3.8.5, DO NOT EDIT.
//
// infohub client HTTP transport
//
// Command:
// $ goa gen
// gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/infohub/design

package client

import (
	"context"
	"net/http"

	goahttp "goa.design/goa/v3/http"
	goa "goa.design/goa/v3/pkg"
)

// Client lists the infohub service endpoint HTTP clients.
type Client struct {
	// Export Doer is the HTTP client used to make requests to the Export endpoint.
	ExportDoer goahttp.Doer

	// Import Doer is the HTTP client used to make requests to the Import endpoint.
	ImportDoer goahttp.Doer

	// RestoreResponseBody controls whether the response bodies are reset after
	// decoding so they can be read again.
	RestoreResponseBody bool

	scheme  string
	host    string
	encoder func(*http.Request) goahttp.Encoder
	decoder func(*http.Response) goahttp.Decoder
}

// NewClient instantiates HTTP clients for all the infohub service servers.
func NewClient(
	scheme string,
	host string,
	doer goahttp.Doer,
	enc func(*http.Request) goahttp.Encoder,
	dec func(*http.Response) goahttp.Decoder,
	restoreBody bool,
) *Client {
	return &Client{
		ExportDoer:          doer,
		ImportDoer:          doer,
		RestoreResponseBody: restoreBody,
		scheme:              scheme,
		host:                host,
		decoder:             dec,
		encoder:             enc,
	}
}

// Export returns an endpoint that makes HTTP requests to the infohub service
// Export server.
func (c *Client) Export() goa.Endpoint {
	var (
		decodeResponse = DecodeExportResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v interface{}) (interface{}, error) {
		req, err := c.BuildExportRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.ExportDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("infohub", "Export", err)
		}
		return decodeResponse(resp)
	}
}

// Import returns an endpoint that makes HTTP requests to the infohub service
// Import server.
func (c *Client) Import() goa.Endpoint {
	var (
		encodeRequest  = EncodeImportRequest(c.encoder)
		decodeResponse = DecodeImportResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v interface{}) (interface{}, error) {
		req, err := c.BuildImportRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		err = encodeRequest(req, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.ImportDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("infohub", "Import", err)
		}
		return decodeResponse(resp)
	}
}
